#! /bin/sh
#
#   makefd.sh -- ϡɥǥõѥ֡ȥեåԡκ
#
#   revision history:
#	0.0: Oct. 26, 2001 by Dai ISHIJIMA
#	0.1: Oct. 22, 2002 (add diskinfo)
#	0.2: May   1, 2004 (4.8R, disklabel, random data)
#
#   usage:
#	# sh makefd.sh
#

#
workdir=/home/dai/wipe-out/current

rc=$workdir/startup.sh
binaries="$workdir/check $workdir/diskinfo $workdir/stuff"
scripts="$workdir/?.sh"

kernel=/sys/compile/MINI/kernel
bins="dd echo sh test expr"
sbins="init mount_cd9660"
devs="std ad0 ad1 acd0"

output=/tmp/wipe-out-02b.flp

# 
if [ ! -f /usr/src/release/write_mfs_in_kernel.c ] ; then
	echo 'unable to compile "write_mfs_in_kernel"'
	exit 1
fi

if [ ! -f $kernel ] ; then
	echo 'no kernel found'
	exit 1
fi


echo "Making write_mfs_in_kernel..."
#
# write_mfs_in_kernel 
#
mkdir /tmp/write_mfs_in_kernel
cd /tmp/write_mfs_in_kernel
cp /usr/src/release/write_mfs_in_kernel.c .
cc -o write_mfs_in_kernel write_mfs_in_kernel.c


echo "Making file system onto MFS..."
#
# MFSե륷ƥ
#
cd /tmp
# 21, 82 -> 10752Х/ȥå, 164ȥå
dd of=mfs-image if=/dev/zero count=164 bs=10752
vnconfig -s labels -c /dev/vn0 mfs-image
disklabel -w -B -b /boot/boot1 -s /boot/boot2 /dev/rvn0c fd1720
newfs -t 2 -u 21 -l 1 -c 40 -i 5120 -m 5 -o space -T fd1720 /dev/rvn0c

# -t [track/cylinder]
# -u [sectors/track]
# -l [interleave factor]
# -i [bytes/inode]
# -m [MINFREE]
# -o [optimize]

echo "Mounting MFS..."
#
# MFSޥȤ
#
mount /dev/vn0c /mnt

echo "Making device files..."
#
# ǥХե
#
mkdir /mnt/dev
cd /mnt/dev
cp /dev/MAKEDEV .
for i in $devs; do
	./MAKEDEV $i
done

echo "Making tmp..."
#
# /tmp ǥ쥯ȥ
#
mkdir /mnt/tmp
chmod 777 /mnt/tmp

mkdir /mnt/mnt
mkdir /mnt/cdrom

echo "Making etc..."
#
# /etc ǥ쥯ȥ
#
mkdir /mnt/etc
cd /mnt/etc
echo 'root:*:0:0:Charlie &:/:/bin/sh' > /mnt/etc/passwd
echo 'root:*:0:0::0:0:Charlie &:/:/bin/sh' > /mnt/etc/master.passwd
pwd_mkdb -d /mnt/etc /mnt/etc/master.passwd

#
#
#
cp $rc /mnt/etc/rc
chmod +x /mnt/etc/rc

echo "Copying binaries..."
#
# /bin
#
mkdir /mnt/bin
cd /mnt/bin
for i in $bins; do
	#gzip < /bin/$i > /mnt/bin/$i
	#chmod +x /mnt/bin/$i
	cp /bin/$i /mnt/bin/$i
done
cd /mnt/bin
ln 'test' '['
cp $binaries /mnt/bin
cp $scripts /mnt/bin

#
# /sbin
#
mkdir /mnt/sbin
cd /mnt/sbin
for i in $sbins; do
	#gzip < /sbin/$i > /mnt/sbin/$i
	#chmod +x /mnt/sbin/$i
	cp /sbin/$i /mnt/sbin/$i
done

#
# MFS򥢥ޥ
#
cd /tmp
umount /mnt
vnconfig -u /dev/vn0

echo "Compressing kernel..."
#
#
#
cp $kernel /tmp
/tmp/write_mfs_in_kernel/write_mfs_in_kernel /tmp/kernel /tmp/mfs-image

#
# ͥ򰵽
#
cd /tmp
gzip --best < /tmp/kernel > /tmp/kernel.gz
chmod +x kernel.gz

#exit 0

echo "Making boot floppy image..."

# 18, 40 -> 9kХ/ȥå, 160ȥå
dd of=floppy-image if=/dev/zero count=160 bs=9216
vnconfig -s labels -c /dev/vn0 floppy-image

# ǥ٥
disklabel -w -B -b /boot/boot1 -s /boot/boot2 /dev/rvn0c fd1440
newfs -t 2 -u 18 -l 1 -c 40 -i 65536 -m 0 -o space /dev/rvn0c

#
# եåԡ᡼ޥ
#
mount /dev/vn0a /mnt

#
# ̤ͥ򥳥ԡ
#
mkdir /mnt/boot
cp /boot/boot1 /mnt/boot
cp /boot/boot2 /mnt/boot
cp /boot/loader /mnt/boot

cp -f /tmp/kernel.gz /mnt/kernel.gz

cd /tmp
umount /mnt
vnconfig -u /dev/vn0

cp /tmp/floppy-image $output

#
# ޤ
#
